;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 䠩   ஢ ⤥쭮  main.asm
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;  rehard_vs
;  resoft_vs
;  write_vol
;  send_2048
;  sdi_out
;  beep
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#define  sound_step  0x04

;-----------------------------------------------------------
; rehard_vs - ன  resoft_vs,   vs
;-----------------------------------------------------------
rehard_vs
        bcf     bit_vs_reset         ; 砥 VS
        call    delay_01s
        call    delay_01s
        bsf     bit_vs_reset         ; 砥 VS
        call    delay_01s

;----------------------------------------------------------;
; resoft_vs                                                ;
; 믮 ணࠬ  VS1001k. 䨣 SDI    ;
; 䥩  奬                                    ;
;----------------------------------------------------------;

resoft_vs
        bcf     bit_vs_cs
	movlw   0x02               ; 
	call    spi2_out
	movlw   0x00               ;  祩 00
	call    spi2_out
	movlw   0x03               ; ᫠ 0304 (ணࠬ )
	call    spi2_out
	movlw   0x04
	call    spi2_out
	bsf     bit_vs_cs
	call    delay_5us
        call    delay_5us
			           ; unreset  ன SDI VS-
	bcf     bit_vs_cs
	movlw   0x02
	call    spi2_out
	movlw   0x00
	call    spi2_out
	movlw   0x03               ; SDI: ᭠砫 㫥 ,   ᯠ
	call    spi2_out            ; ⠪⮢ ᨣ, ० slave
        movlw   0x80
        andwf   mystat,W
	call    spi2_out
	bsf     bit_vs_cs
        call    delay_5us
        call    delay_5us

        if (XTALI != 24576)        ; ᫨   VS  ࠢ 24,576MHz
         bcf     bit_vs_cs             ;   㦭 㪠   . ॣ
	 movlw   0x02
	 call    spi2_out
	 movlw   0x03
	 call    spi2_out
	 movlw   HIGH (FREQ)
	 call    spi2_out
	 movlw   LOW  (FREQ)
	 call    spi2_out
	 bsf     bit_vs_cs
        endif
	call    delay_5us
;----------------------------------------------------------;
; write_vol,  뢠 ⤥쭮  resoft_vs        ;
; 뢠 ஬   ७ bass/treble        ;
;----------------------------------------------------------;
write_vol
        bcf     bit_vs_cs              ; write vol
	movlw   0x02
	call    spi2_out
	movlw   0x0b
	call    spi2_out
	movf    vol,w
	call    spi2_out
        movf    vol,w
	call    spi2_out
	bsf     bit_vs_cs
        call    delay_5us


        bcf     bit_vs_cs              ; write bass/treble enhahcer bit
	movlw   0x02
	call    spi2_out
	movlw   0x00
	call    spi2_out
	movlw   0x03
	call    spi2_out
        movlw   0x80
        andwf   mystat,W
	call    spi2_out
	bsf     bit_vs_cs
        ;goto    delay_5us

delay_5us                          ; ᫥  饭  SCI VS-
	movlw d'18'                 ; ୮ 饭  ࠭ 祬 १
        movwf tmpz             ; 5us

        decfsz tmpz,F
        goto   $-1

        return
;----------------------------------------------------------------;
; send_2048                                                      ;
; ᫥ 砭 । ४  SDI 뫠 2048 㫥.    ;
;  ᪫祭 뢠 ᫥ ᥪ㭤 ४                   ;
;----------------------------------------------------------------;
send_2048
        movlw   0x64
        movwf   tmpz+1
_send32_0
        btfss   bit_vs_dreq
        goto    $-1

        movlw   0x32
        movwf   tmpz
_send_zero
        clrw
        call    sdi_out
        decfsz  tmpz,F
        goto    _send_zero

        decfsz  tmpz+1,F
        goto    _send32_0
        return
;-------------------------------------------------------;
; sdi_out - ࠢ   W  SDI                   ;
;-------------------------------------------------------;
sdi_out
        bsf	bit_vs_bsync          ; ।   ᨭ஭騬 ⮬
	movwf	TXREG             ;  砭  TXIF , .. 
	nop                       ;    襭 ।,    
        nop                       ;  TXREG,    ⮦⢥-
	nop                       ; 묨 ᮡﬨ.
	bcf	bit_vs_bsync
	nop
        nop
        nop
	nop
	return
; 1 ࠧ ""
beep
        movwf   answer
        call    delay_500us
        movlw   0x53
        call    sdi_out
        movlw   0xef
        call    sdi_out
        movlw   0x6e
        call    sdi_out
        movf    answer,W
        call    sdi_out
        clrw
        call    sdi_out
        call    sdi_out
        call    sdi_out
        call    sdi_out
        call    delay_01s
        movlw   0x45
        call    sdi_out
        movlw   0x78
        call    sdi_out
        movlw   0x69
        call    sdi_out
        movlw   0x74
        call    sdi_out
        clrw
        call    sdi_out
        call    sdi_out
        call    sdi_out
        call    sdi_out
        return
;--------------end of vs.asm-------------------;